﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using ArtOfTest.WebAii.Silverlight.UI;
using ArtOfTest.WebAii.TestTemplates;
using ArtOfTest.WebAii.Core;
using ArtOfTest.WebAii.Silverlight;
using System.Threading;

namespace TestProject1
{
    [TestClass]
    public class UnitTest1 : BaseTest
    {
        [TestMethod]
        public void FindByTextContent_ComboBox()
        {
            Manager.LaunchNewBrowser(BrowserType.InternetExplorer);
            ActiveBrowser.NavigateTo("http://localhost:16696/SilverlightApplication1TestPage.aspx");
            SilverlightApp app = ActiveBrowser.SilverlightApps()[0];

            app.RefreshVisualTrees();

            Assert.IsNotNull(app.Find.ByTextContent("<Select Day>"));
        }

        [TestMethod]
        public void SelectByTextContent_ComboBox()
        {
            Manager.LaunchNewBrowser(BrowserType.InternetExplorer);
            ActiveBrowser.NavigateTo("http://localhost:16696/SilverlightApplication1TestPage.aspx");
            SilverlightApp app = ActiveBrowser.SilverlightApps()[0];

            app.RefreshVisualTrees();

            ComboBox combo = app.Find.ByType<ComboBox>();
            Assert.IsNotNull(combo);
            combo.SelectItemByText(true, "<Select Day>");
        }

        private TestContext testContextInstance = null;
        /// <summary>
        ///Gets or sets the VS test context which provides
        ///information about and functionality for the
        ///current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        [TestInitialize]
        public void TestInitialize()
        {
            Settings settings = GetSettings();

            // Override the settings you want. For example:
            settings.Web.EnableSilverlight = true;

            // Now call Initialize again with your updated settings object
            Initialize(settings, new TestContextWriteLine(this.TestContext.WriteLine));

            // Set the current test method. This is needed for WebAii to discover
            // its custom TestAttributes set on methods and classes.
            // This method should always exist in [TestInitialize()] method.
            SetTestMethod(this, (string)TestContext.Properties["TestName"]);
        }

        [TestCleanup()]
        public void MyTestCleanup()
        {
            // Shuts down WebAii manager and closes all browsers currently running
            this.CleanUp();
        }
    }
}
